import jarvis
from discord.ext import commands


def user_is_bot_admin():
    def predicate(ctx):
        if getattr(jarvis.config.get_config(), "admins", None):
            return ctx.author.id in jarvis.config.get_config().admins
        else:
            return False

    return commands.check(predicate)


def admin_or_permissions(**perms):
    original = commands.has_permissions(**perms).predicate

    async def extended_check(ctx):
        return await commands.has_permissions(administrator=True).predicate(
            ctx
        ) or await original(ctx)

    return commands.check(extended_check)
